var express = require("express");
const router = express.Router();
const multer = require("multer");
var uploads = multer({
  dest: "./upload",
});
var xlsx = require("node-xlsx");
var fs = require("fs");
var path = require("path");
const pgClient = require("../DataBase/Postgresql/pgClient.js"); //pg 查询引擎
let uploaddistDir = JSON.parse(
  fs.readFileSync(
    path.join(__dirname, "../../../config/baseConfig.json"),
    "utf-8"
  )
);

/* GET home page. */
router.get("/", function (req, res, next) {
  res.render("index", {
    title: "Express",
  });
});
router.post("/up", uploads.single("file"), async function (req, res) {
  //给文件添加后缀名
  var pash = path.extname(req.file.originalname);
  fs.renameSync(req.file.path, req.file.path + pash, (err) => {});
  // 第一个文件sheet1
  var { data } = xlsx.parse(req.file.path + pash)[0];
  //  切的第一排表头
  data.splice(0, 1);
  // console.log(data);
  //定义一个空列表，并且循环列表
  data.forEach((item) => {
    let sql = `INSERT INTO t_cj_jtjc ("sjlc","zqpm") VALUES (${item[0]},${item[1]})`;
    pgClient.query(sql).then((data) => {
      res.send(data);
    });
  });
  const myDate = new Date();
  const tableName = "JingTaiJC";
  const time = myDate.toLocaleDateString();
  const fileName = req.file.originalname;
  const sql1 = `INSERT INTO t_file_table ("name","time","table") VALUES ('${fileName}','${time}','${tableName}')`;
  pgClient.query(sql1).then((data1) => {
    res.send(data1);
  });

  res.json({
    code: 200,
    msg: "批量导入成功",
  });
});

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    let distDir = uploaddistDir.uploaddistDir;
    cb(null, distDir);
  },
  filename: function (req, file, cb) {
    cb(null, `${file.originalname}`);
  },
});

const upload = multer({ storage: storage });

router.post("/uploadFilesList", upload.fields([{ name: "file" }]), (e) => {});

// 导出模块（在 app.js 中引入）
module.exports = router;
